#include <bits/stdc++.h>

using namespace std;

void optimizeio()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool binarnaPretraga(vector<int> v, int X, int N)
{
    int L = 0;
    int R = N - 1;
    while(L <= R)
    {
        int S = L + (R - L)/2;
        if(v[S] == X)
            return true;
        else if(X > v[S])
            L = S + 1;
        else
            R = S - 1;
    }
    return false;
}

int main()
{
    optimizeio();
    int n, q;
    vector<int> a;
    vector<int> b;
    cin >> n >> q;
    for(int i = 0; i < n; i++)
    {
        int broj;
        cin >> broj;
        a.push_back(broj);
    }
    for(int i = 0; i < q; i++)
    {
        int broj;
        cin >> broj;
        b.push_back(broj);
    }

    sort(a.begin(), a.end());

    for(int i = 0; i < q; i++)
    {
        int X;
        int indexPrvo, indexPoslednje;
        bool nalaziUNizu = binarnaPretraga(a, b[i], n);
        indexPrvo = lower_bound(a.begin(), a.end(), b[i]) - a.begin();
        indexPoslednje = upper_bound(a.begin(), a.end(), b[i]) - a.begin();
        if(nalaziUNizu)
        {
            indexPoslednje -= nalaziUNizu;
            if(indexPrvo < n/2) X = abs(n - 1 - 2*indexPrvo);
            else if(indexPrvo == n/2) X = 0;
            else X = abs(n - 2*indexPrvo);
            if(indexPrvo != n/2)
            {
                for(int i = indexPrvo + 1; i <= indexPoslednje; i++)
                {
                    if(i < n/2)
                    {
                        X = min(X, abs(n - 1 - 2*i));
                    }
                    else if(i == n / 2)
                    {
                        X = 0;
                    }
                    else
                    {
                        X = min(X, abs(n - 2*i));
                    }
                }
            }
        }
        else
        {
            if(b[i] < a[0])
            {
                X = abs(n + 1);
            }
            else if(b[i] > a[n - 1])
            {
                X = abs(n);
            }
            else
            {
                if(indexPrvo < (n + 1)/2)
                {
                    X = abs(n + 1 - 1 - 2*indexPrvo) + 1;
                }
                else if(indexPrvo == (n + 1)/2)
                {
                    X = 1;
                }
                else
                {
                    X = abs(n + 1 - 2*indexPrvo) + 1;
                }
            }
        }

        cout << X << "\n";
    }
    return 0;
}